//
//  YHSearchInfoCell.swift
//  galaxy
//
//  Created by edy on 2024/4/8.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import UIKit

class YHSearchInfoCell: UITableViewCell {

    static let cellReuseIdentifier = "YHSearchInfoCell"
    
    override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
        super.init(style: style, reuseIdentifier: reuseIdentifier)
        setupUI()
    }
    
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    lazy var headImgView: UIImageView = {
        let imagV = UIImageView()
        imagV.contentMode = .scaleAspectFill
        imagV.clipsToBounds = true
        imagV.image = UIImage(named: "home_cell0_head_icon")
        return imagV
    }()
    
    lazy var titleLabel: UILabel =  {
        var label = UILabel()
        label.font = .PFSC_R(ofSize: 12)
        label.textAlignment = .left
        label.textColor = UIColor(hex: 0x121A26)
        label.numberOfLines = 2
        return label
    }()
    
    
    func setupUI() {
        
        contentView.backgroundColor = .white
        contentView.addSubview(headImgView)
        contentView.addSubview(titleLabel)
        
        headImgView.snp.makeConstraints { make in
            make.width.height.equalTo(70.0)
            make.centerY.equalToSuperview()
            make.left.equalToSuperview().offset(20)
        }
        
        titleLabel.snp.makeConstraints { make in
            make.centerY.equalToSuperview()
            make.left.equalTo(headImgView.snp.right).offset(20)
            make.right.equalToSuperview().offset(-20)
        }
    }

}
